routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\PostController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
}); 
  

Route::resource('categories', CategoryController::class);
Route::resource('posts', PostController::class);
Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Post.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
class Post extends Model
{
    use HasFactory, SoftDeletes;
    protected $fillable = [ 
        'title', 
        'category_id', 
        'description' 
    ];  

    public function category(){
        return $this->hasOne(Category::class, 'id', 'category_id');
    }

}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Models\Post;
use App\Models\Category;
use Illuminate\Http\Request;

class PostController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        if ($request->has('trashed')) {
            $posts = Post::onlyTrashed()
                ->latest()->paginate(10);
        } else {
            $posts = Post::latest()->paginate(10);
        } 
        return view('posts.index',compact('posts')) 
            ->with('i', (request()->input('page', 1) - 1) * 5); 
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $categories = Category::withoutTrashed()->get()->pluck('title','id'); 
        $selected = '';
        return view('posts.create',compact('categories','selected'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([ 
            'title' => 'required',  
            'category_id' => 'required',   
            'description' => 'required', 
        ]); 
       // dd($request->title); 
        Post::create($request->all());   
        return redirect()->route('posts.index') 
                        ->with('success','Post created successfully.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function show(Post $post)
    {
        return view('posts.show',compact('post'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function edit(Post $post)
    { 
        $categories = Category::withoutTrashed()->get()->pluck('title','id'); 
        $selected = $post->category_id;
 
        return view('posts.edit',compact('post','categories','selected'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Post $post)
    { 
        $request->validate([ 
            'title' => 'required',  
            'category_id' => 'required',  
            'description' => 'required', 
        ]);  
        $postData = [
            'title' => $request->title,
            'category_id' => $request->category_id,
            'description' => $request->description
        ]; 
 
        $post->update($postData); 
        return redirect()->route('posts.index') 
                        ->with('success','Post updated successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function destroy(Post $post)
    {  
        $post->delete();  
        return redirect()->route('posts.index') 
                        ->with('success','Post deleted successfully');
    }
}

resources/views/posts/create.blade.php
@extends('posts.layout') 

@section('content')

<div class="row">

    <div class="col-lg-12 margin-tb">

        <div class="pull-left">

            <h2>Add New Post</h2>

        </div>

        <div class="pull-right">

            <a class="btn btn-primary" href="{{ route('posts.index') }}"> Back</a>

        </div>

    </div>

</div>

   

@if ($errors->any())

    <div class="alert alert-danger">

        <strong>Whoops!</strong> There were some problems with your input.<br><br>

        <ul>

            @foreach ($errors->all() as $error)

                <li>{{ $error }}</li>

            @endforeach

        </ul>

    </div>

@endif

   

<form action="{{ route('posts.store') }}" method="POST">

    @csrf

   

     <div class="row">
     <div class="col-xs-12 col-sm-12 col-md-12"> 
            <div class="form-group">
            <strong>Category:</strong>
            {!! Form::select('myselect', $categories, $selected, ['class' => 'form-control','name'=>'category_id']) !!}
            </div>

        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">

            <div class="form-group">

                <strong>Name:</strong>

                <input type="text" name="title" class="form-control" placeholder="Title">

            </div>

        </div>

        <div class="col-xs-12 col-sm-12 col-md-12">

            <div class="form-group">

                <strong>Description:</strong>

                <textarea class="form-control" style="height:150px" name="description" placeholder="Description"></textarea>

            </div>

        </div>

        <div class="col-xs-12 col-sm-12 col-md-12 text-center">

                <button type="submit" class="btn btn-primary">Submit</button>

        </div>

    </div>

   

</form>

@endsection

resources/views/posts/edit.blade.php
@extends('posts.layout')

   

@section('content')

    <div class="row">

        <div class="col-lg-12 margin-tb">

            <div class="pull-left">

                <h2>Edit Post</h2>

            </div>

            <div class="pull-right">

                <a class="btn btn-primary" href="{{ route('posts.index') }}"> Back</a>

            </div>

        </div>

    </div>

   

    @if ($errors->any())

        <div class="alert alert-danger">

            <strong>Whoops!</strong> There were some problems with your input.<br><br>

            <ul>

                @foreach ($errors->all() as $error)

                    <li>{{ $error }}</li>

                @endforeach

            </ul>

        </div>

    @endif

  

    <form action="{{ route('posts.update',$post->id) }}" method="POST">

        @csrf

        @method('PUT')

   

         <div class="row">
       


         <div class="col-xs-12 col-sm-12 col-md-12"> 
            <div class="form-group">
            <strong>Category:</strong>
            {!! Form::select('myselect', $categories, $selected, ['class' => 'form-control','name'=>'category_id']) !!}
            </div>


            

        </div>

        
            <div class="col-xs-12 col-sm-12 col-md-12">

                <div class="form-group">

                    <strong>Title:</strong>

                    <input type="text" name="title" value="{{ $post->title }}" class="form-control" placeholder="Title">

                </div>

            </div>

            <div class="col-xs-12 col-sm-12 col-md-12">

                <div class="form-group">

                    <strong>Description:</strong>

                    <textarea class="form-control" style="height:150px" name="description" placeholder="Description">{{ $post->description }}</textarea>

                </div>

            </div>

            <div class="col-xs-12 col-sm-12 col-md-12 text-center">

              <button type="submit" class="btn btn-primary">Submit</button>

            </div>

        </div>

   

    </form>

@endsection

resources/views/posts/index.blade.php
@extends('posts.layout')

 

@section('content')

    <div class="row">

        <div class="col-lg-12 margin-tb">

            <div class="pull-left">

                <h2> Post Management</h2>

            </div>

            <div class="pull-right">

                <a class="btn btn-success" href="{{ route('posts.create') }}"> Create New Post</a>

            </div>

        </div>

    </div>

   

    @if ($message = Session::get('success'))

        <div class="alert alert-success">

            <p>{{ $message }}</p>

        </div>

    @endif
 
    <table class="table table-bordered">

        <tr>

            <th>No</th>

            <th>Title</th>
            <th>Category</th> 
            <th>Status</th>

            <th width="280px">Action</th>

        </tr>

        @foreach ($posts as $data) 

        <tr>

            <td>{{ ++$i }}</td>

            <td>{{ $data->title }}</td>
            <td>{{ $data->category->title }}</td>

            <td>{{ $data->status }}</td>

            <td>

                <form action="{{ route('posts.destroy',$data->id) }}" method="POST">

   

                    <a class="btn btn-info" href="{{ route('posts.show',$data->id) }}">Show</a>

    

                    <a class="btn btn-primary" href="{{ route('posts.edit',$data->id) }}">Edit</a>

   

                    @csrf

                    @method('DELETE')

      

                    <button type="submit" class="btn btn-danger">Delete</button>

                </form>

            </td>

        </tr>

        @endforeach

    </table>

  

    {!! $posts->links() !!}

      

@endsection

resources/views/posts/layout.blade.php
<!DOCTYPE html>

<html>

<head>

    <title> Post Management</title>

    <link href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.0.0-alpha/css/bootstrap.css" rel="stylesheet">

</head>

<body>

  

<div class="container">

    @yield('content')

</div>

   

</body>

</html>

resources/views/posts/show.blade.php
@extends('categories.layout') 

@section('content')

    <div class="row">

        <div class="col-lg-12 margin-tb">

            <div class="pull-left">

                <h2> Show Post</h2>

            </div>

            <div class="pull-right">

                <a class="btn btn-primary" href="{{ route('posts.index') }}"> Back</a>

            </div>

        </div>

    </div>

   

    <div class="row">

        <div class="col-xs-12 col-sm-12 col-md-12">

            <div class="form-group">

                <strong>Title:</strong>

                {{ $post->title }}

            </div>
            <div class="form-group">

<strong>Category:</strong>

{{ $post->category->title }}

</div>
            <div class="form-group">

                <strong>Status:</strong>

                {{ $post->status }}

            </div>

            <div class="form-group">

                <strong>Description:</strong>

                {{ $post->description }}

            </div>



        </div>

         

    </div>

@endsection